var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { uuid } from "./utils";
var API_CALL_RESULTS = {};
var FOOT_PRINTS = [];
var _throttleWait = 5 * 60 * 1000; // millionseconds
var ThrottleUtil = /** @class */ (function () {
    function ThrottleUtil() {
        this._key = uuid();
    }
    ThrottleUtil.prototype.setKey = function (key) {
        this._key = key || this._key;
    };
    ThrottleUtil.prototype.throttle = function (fn, ms) {
        var timer = 0;
        return function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            clearTimeout(timer);
            timer = setTimeout(fn.bind.apply(fn, __spreadArray([null], args, false)), ms || 0);
        };
    };
    ThrottleUtil.prototype.throttleAsync = function (callback) {
        var _this = this;
        var waiting = false;
        var getFootprint = function (args) {
            var params = args.map(function (arg) {
                if (typeof arg === 'object' &&
                    typeof arg !== "function" &&
                    arg !== null) {
                    if (Array.isArray(arg)) {
                        return arg.map(function (a) { return (__assign(__assign({}, a), { timestamp: null })); });
                    }
                    else {
                        return __assign(__assign({}, arg), { timestamp: null });
                    }
                }
                return arg;
            });
            return _this._key + JSON.stringify(params);
        };
        return function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return __awaiter(this, void 0, void 0, function () {
                var footprint, idx, _a, _b;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            footprint = getFootprint(args);
                            idx = FOOT_PRINTS.findIndex(function (f) { return f === footprint; });
                            if (!(!waiting || idx === -1)) return [3 /*break*/, 2];
                            waiting = true;
                            if (idx === -1) {
                                FOOT_PRINTS.push(footprint);
                            }
                            _a = API_CALL_RESULTS;
                            _b = footprint;
                            return [4 /*yield*/, callback.apply(null, args)];
                        case 1:
                            _a[_b] = _c.sent();
                            setTimeout(function () {
                                waiting = false;
                            }, _throttleWait);
                            _c.label = 2;
                        case 2: return [2 /*return*/, API_CALL_RESULTS[footprint]];
                    }
                });
            });
        };
    };
    return ThrottleUtil;
}());
export default new ThrottleUtil();
//# sourceMappingURL=throttleutil.js.map